
var livePreview = {
  app : null,
  _enabled : false,
  timeout : -1,
  batch : false,

  init : function(aApp) {
    this.app = aApp;
  
    this.getEditor().transactionManager.AddListener(this);
    this.refresh();
  },

  get enabled() {
    return this._enabled;
  },
  set enabled(aEnabled) {
    this._enabled = aEnabled;
  },
  
  refresh : function() {
    if (!this._enabled || this.batch)
      return;

    if (this.timeout != -1)
      window.clearTimeout(this.timeout);
  
    var app = this.app;
    this.timeout = window.setTimeout(function() { app.refreshPreview(); }, 1000); 
  },

  getEditor : function() {
    return this.app.getEditor().QueryInterface(Components.interfaces.nsIEditor);
  },

  didDo : function(aManager, aTransaction, aResult) {
    this.refresh();
  },

  didUndo : function(aManager, aTransaction, aResult) {
    this.refresh();
  },

  didRedo : function(aManager, aTransaction, aResult) {
    this.refresh();
  },

  didBeginBatch : function(aManager, aResult) {
    this.batch = true;
  },

  didEndBatch : function(aManager, aResult) {
    this.batch = false;
    this.refresh();
  },

  didMerge : function(aManager, aTopTransaction, aTransactionToMerge, aDidMerge, aResult) { 
    this.refresh();
  },

  willDo : function(aManager, aTransaction) { return false; },
  willUndo : function(aManager, aTransaction) { return false; }, 
  willRedo : function(aManager, aTransaction) { return false; }, 
  willBeginBatch : function(aManager) { return false; },
  willEndBatch : function(aManager) { return false; }, 
  willMerge : function(aManager, aTopTransaction, aTransactionToMerge) { return false; }
};