
const ERROR_NS = "http://www.mozilla.org/newlayout/xml/parsererror.xml";

var XULChecker = {
  xulSchema : [],
  xmlLookup : null,
  xmlScanner : null,
  
  init : function(aSchemaFile) {
    var req = new XMLHttpRequest();
    req.open("GET", aSchemaFile, false); 
    req.send(null);
  
    this.xulSchema = eval("(" + req.responseText + ")");
  },
  
  checkString : function(aText) {
    var parser = new DOMParser();
    this.xmlScanner = parser.parseFromString(aText, "text/xml");
    
    var rootNode = this.xmlScanner.documentElement;
    if ((rootNode.tagName == "parserError") || (rootNode.namespaceURI == ERROR_NS)) {
      log("xml error");
      return;
    }
    
//    this.xmlLookup = parser.parseFromString(aText, "text/xml");
    this.checkElement(rootNode);
  },

  checkElement : function(testElement) {
    var schemaElement = this.findElement(testElement.nodeName);
    if (schemaElement) {
      var attributes = testElement.attributes;
      for(var i=0; i<attributes.length; i++) {
        if (attributes[i].name == "xmlns")
          continue;
          
        if (schemaElement.attributes.indexOf(attributes[i].name) == -1)  {
          var schemaBase = this.findElement("xulelement");
          if (schemaBase && schemaBase.attributes.indexOf(attributes[i].name) == -1)  {
            this.log("illegal attribute: " + testElement.nodeName + "[" + attributes[i].name + "]");
          }
        }
      }
    }
    else {
      this.log("illegal element: " + testElement.nodeName);
    }
    
    for (var i=0; i<testElement.childNodes.length; i++) {
      if (testElement.childNodes[i].nodeType == 1) {
        this.checkElement(testElement.childNodes[i]);
      }
    }
  },

  log : function(str) {
    Components.classes['@mozilla.org/consoleservice;1']
              .getService(Components.interfaces.nsIConsoleService)
              .logStringMessage(str);
  },

  findElement : function(element) {
    for (var iElement in this.xulSchema) {
      if (element == this.xulSchema[iElement].name) {
        return this.xulSchema[iElement];
      }
    }
    return null;
  }
};